// ignore_for_file: non_constant_identifier_names
import "json_dart.dart";
// import "dart:convert";

import "sender_data.dart";
import "receiver_data.dart";
import "track_history_data.dart";

class DeliveryData extends JsonScheme {
  DeliveryData(super.rawData);

  static Map get defaultData {
    return {
      "@type": "deliveryData",
      "id": "005208225151",
      "sender": {
        "@type": "senderData",
        "name": "Decathlon Indonesia",
        "address": "DKI Jakarta"
      },
      "receiver": {
        "@type": "receiverData",
        "name": "Hendi",
        "address": "Kotabaru, Kab. Karawang"
      },
      "service": "REG",
      "weight": 1,
      "platform": "Tokopedia",
      "send_date": "2023-05-23 03:32",
      "real_price": 0,
      "total_price": 14000,
      "track_history": [
        {
          "@type": "trackHistoryData",
          "date": "2023-05-24 10:13",
          "status": "DELIVERED",
          "message": ""
        },
        {
          "@type": "trackHistoryData",
          "date": "2023-05-22 17:59",
          "status": "PICK",
          "message": "Paket telah di pick up oleh [SIGESIT - Pikri Aikal]"
        },
        {
          "@type": "trackHistoryData",
          "date": "2023-05-22 20:32",
          "status": "IN",
          "message":
              "Paket telah di input (manifested) di Jakarta Utara [Jakut Pegangsaan Dua]"
        },
        {
          "@type": "trackHistoryData",
          "date": "2023-05-23 04:01",
          "status": "OUT",
          "message": "Paket keluar dari Jakarta Utara [Jakut Pegangsaan Dua]"
        },
        {
          "@type": "trackHistoryData",
          "date": "2023-05-23 07:40",
          "status": "IN",
          "message":
              "Paket telah di terima di Jakarta Timur [Jakarta Sortation 2]"
        },
        {
          "@type": "trackHistoryData",
          "date": "2023-05-23 07:41",
          "status": "OUT",
          "message": "Paket keluar dari Jakarta Timur [Jakarta Sortation 2]"
        },
        {
          "@type": "trackHistoryData",
          "date": "2023-05-23 13:21",
          "status": "IN",
          "message": "Paket telah di terima di Karawang [Cikapur Sortation]"
        },
        {
          "@type": "trackHistoryData",
          "date": "2023-05-23 14:21",
          "status": "OUT",
          "message": "Paket keluar dari Karawang [Cikapur Sortation]"
        },
        {
          "@type": "trackHistoryData",
          "date": "2023-05-23 15:54",
          "status": "IN",
          "message":
              "Paket telah di terima di Karawang [Karawang Jatisari Mekarsari]"
        },
        {
          "@type": "trackHistoryData",
          "date": "2023-05-24 08:19",
          "status": "ANT",
          "message": "Paket dibawa [SIGESIT - Windi Wiliyadi]"
        },
        {
          "@type": "trackHistoryData",
          "date": "2023-05-24 10:13",
          "status": "DELIVERED",
          "message": ""
        }
      ]
    };
  }

  String? get special_type {
    try {
      if (rawData["@type"] is String == false) {
        return null;
      }
      return rawData["@type"] as String;
    } catch (e) {
      return null;
    }
  }

  String? get id {
    try {
      if (rawData["id"] is String == false) {
        return null;
      }
      return rawData["id"] as String;
    } catch (e) {
      return null;
    }
  }

  SenderData get sender {
    try {
      if (rawData["sender"] is Map == false) {
        return SenderData({});
      }
      return SenderData(rawData["sender"] as Map);
    } catch (e) {
      return SenderData({});
    }
  }

  ReceiverData get receiver {
    try {
      if (rawData["receiver"] is Map == false) {
        return ReceiverData({});
      }
      return ReceiverData(rawData["receiver"] as Map);
    } catch (e) {
      return ReceiverData({});
    }
  }

  String? get service {
    try {
      if (rawData["service"] is String == false) {
        return null;
      }
      return rawData["service"] as String;
    } catch (e) {
      return null;
    }
  }

  int? get weight {
    try {
      if (rawData["weight"] is int == false) {
        return null;
      }
      return rawData["weight"] as int;
    } catch (e) {
      return null;
    }
  }

  String? get platform {
    try {
      if (rawData["platform"] is String == false) {
        return null;
      }
      return rawData["platform"] as String;
    } catch (e) {
      return null;
    }
  }

  String? get send_date {
    try {
      if (rawData["send_date"] is String == false) {
        return null;
      }
      return rawData["send_date"] as String;
    } catch (e) {
      return null;
    }
  }

  int? get real_price {
    try {
      if (rawData["real_price"] is int == false) {
        return null;
      }
      return rawData["real_price"] as int;
    } catch (e) {
      return null;
    }
  }

  int? get total_price {
    try {
      if (rawData["total_price"] is int == false) {
        return null;
      }
      return rawData["total_price"] as int;
    } catch (e) {
      return null;
    }
  }

  List<TrackHistoryData> get track_history {
    try {
      if (rawData["track_history"] is List == false) {
        return [];
      }
      return (rawData["track_history"] as List)
          .map((e) => TrackHistoryData(e as Map))
          .toList()
          .cast<TrackHistoryData>();
    } catch (e) {
      return [];
    }
  }

  static DeliveryData create({
    String special_type = "deliveryData",
    String? id,
    SenderData? sender,
    ReceiverData? receiver,
    String? service,
    int? weight,
    String? platform,
    String? send_date,
    int? real_price,
    int? total_price,
    List<TrackHistoryData>? track_history,
  }) {
    // DeliveryData deliveryData = DeliveryData({

    DeliveryData deliveryData_data_create = DeliveryData({
      "@type": special_type,
      "id": id,
      "sender": (sender != null) ? sender.toJson() : null,
      "receiver": (receiver != null) ? receiver.toJson() : null,
      "service": service,
      "weight": weight,
      "platform": platform,
      "send_date": send_date,
      "real_price": real_price,
      "total_price": total_price,
      "track_history": (track_history != null) ? track_history.toJson() : null,
    });

// return deliveryData;
    return deliveryData_data_create;
  }
}
