// ignore_for_file: non_constant_identifier_names
import "json_dart.dart";
// import "dart:convert";

import "berdu_track_data_logistic.dart";
import "berdu_track_data_details.dart";
import "berdu_track_data_consigner.dart";
import "berdu_track_data_consignee.dart";

class BerduTrackData extends JsonSchemeRaw {
  BerduTrackData(super.rawData);

  static Map get defaultData {
    return {
      "@type": "berduTrackData",
      "referenceNo": "CM96392284741",
      "logistic": {
        "@type": "berduTrackDataLogistic",
        "id": "1",
        "__typename": "Logistic"
      },
      "shipmentDate": "",
      "details": [
        {
          "@type": "berduTrackDataDetails",
          "datetime": "2023-05-16T02:56:00+07:00",
          "shipperStatus": null,
          "logisticStatus": {
            "@type": "berduTrackDataDetailLogisticStatus",
            "name": "SHIPMENT RECEIVED BY JNE COUNTER OFFICER AT [variable]",
            "description": "SHIPMENT RECEIVED BY JNE COUNTER OFFICER AT [SOLO]",
            "__typename": "TrackingDirectStatus"
          },
          "__typename": "TrackingDirectDetail"
        }
      ],
      "consigner": {
        "@type": "berduTrackDataConsigner",
        "name": "AEROSTREET",
        "address": "SOC10000",
        "__typename": "TrackingDirectIdentity"
      },
      "consignee": {
        "@type": "berduTrackDataConsignee",
        "name": "SARWOTO",
        "address": "",
        "__typename": "TrackingDirectIdentity"
      },
      "__typename": "TrackingDirect"
    };
  }

  String? get special_type {
    try {
      if (rawData["@type"] is String == false) {
        return null;
      }
      return rawData["@type"] as String;
    } catch (e) {
      return null;
    }
  }

  String? get referenceNo {
    try {
      if (rawData["referenceNo"] is String == false) {
        return null;
      }
      return rawData["referenceNo"] as String;
    } catch (e) {
      return null;
    }
  }

  BerduTrackDataLogistic get logistic {
    try {
      if (rawData["logistic"] is Map == false) {
        return BerduTrackDataLogistic({});
      }
      return BerduTrackDataLogistic(rawData["logistic"] as Map);
    } catch (e) {
      return BerduTrackDataLogistic({});
    }
  }

  String? get shipmentDate {
    try {
      if (rawData["shipmentDate"] is String == false) {
        return null;
      }
      return rawData["shipmentDate"] as String;
    } catch (e) {
      return null;
    }
  }

  List<BerduTrackDataDetails> get details {
    try {
      if (rawData["details"] is List == false) {
        return [];
      }
      return (rawData["details"] as List)
          .map((e) => BerduTrackDataDetails(e as Map))
          .toList()
          .cast<BerduTrackDataDetails>();
    } catch (e) {
      return [];
    }
  }

  BerduTrackDataConsigner get consigner {
    try {
      if (rawData["consigner"] is Map == false) {
        return BerduTrackDataConsigner({});
      }
      return BerduTrackDataConsigner(rawData["consigner"] as Map);
    } catch (e) {
      return BerduTrackDataConsigner({});
    }
  }

  BerduTrackDataConsignee get consignee {
    try {
      if (rawData["consignee"] is Map == false) {
        return BerduTrackDataConsignee({});
      }
      return BerduTrackDataConsignee(rawData["consignee"] as Map);
    } catch (e) {
      return BerduTrackDataConsignee({});
    }
  }

  String? get __typename {
    try {
      if (rawData["__typename"] is String == false) {
        return null;
      }
      return rawData["__typename"] as String;
    } catch (e) {
      return null;
    }
  }

  static BerduTrackData create({
    String special_type = "berduTrackData",
    String? referenceNo,
    BerduTrackDataLogistic? logistic,
    String? shipmentDate,
    List<BerduTrackDataDetails>? details,
    BerduTrackDataConsigner? consigner,
    BerduTrackDataConsignee? consignee,
    String? typename,
  }) {
    // BerduTrackData berduTrackData = BerduTrackData({

    BerduTrackData berduTrackData_data_create = BerduTrackData({
      "@type": special_type,
      "referenceNo": referenceNo,
      "logistic": (logistic != null) ? logistic.toJson() : null,
      "shipmentDate": shipmentDate,
      "details": (details != null) ? details.toJson() : null,
      "consigner": (consigner != null) ? consigner.toJson() : null,
      "consignee": (consignee != null) ? consignee.toJson() : null,
      "__typename": typename,
    });

// return berduTrackData;
    return berduTrackData_data_create;
  }
}
