// ignore_for_file: non_constant_identifier_names
import "json_dart.dart";
// import "dart:convert";

import "berdu_track_data_detail_logistic_status.dart";

class BerduTrackDataDetails extends JsonSchemeRaw {
  BerduTrackDataDetails(super.rawData);

  static Map get defaultData {
    return {
      "@type": "berduTrackDataDetails",
      "datetime": "2023-05-16T02:56:00+07:00",
      "shipperStatus": null,
      "logisticStatus": {
        "@type": "berduTrackDataDetailLogisticStatus",
        "name": "SHIPMENT RECEIVED BY JNE COUNTER OFFICER AT [variable]",
        "description": "SHIPMENT RECEIVED BY JNE COUNTER OFFICER AT [SOLO]",
        "__typename": "TrackingDirectStatus"
      },
      "__typename": "TrackingDirectDetail"
    };
  }

  String? get special_type {
    try {
      if (rawData["@type"] is String == false) {
        return null;
      }
      return rawData["@type"] as String;
    } catch (e) {
      return null;
    }
  }

  String? get datetime {
    try {
      if (rawData["datetime"] is String == false) {
        return null;
      }
      return rawData["datetime"] as String;
    } catch (e) {
      return null;
    }
  }

  Object? get shipperStatus {
    try {
      if (rawData["shipperStatus"] is Object == false) {
        return null;
      }
      return rawData["shipperStatus"] as Object;
    } catch (e) {
      return null;
    }
  }

  BerduTrackDataDetailLogisticStatus get logisticStatus {
    try {
      if (rawData["logisticStatus"] is Map == false) {
        return BerduTrackDataDetailLogisticStatus({});
      }
      return BerduTrackDataDetailLogisticStatus(
          rawData["logisticStatus"] as Map);
    } catch (e) {
      return BerduTrackDataDetailLogisticStatus({});
    }
  }

  String? get __typename {
    try {
      if (rawData["__typename"] is String == false) {
        return null;
      }
      return rawData["__typename"] as String;
    } catch (e) {
      return null;
    }
  }

  static BerduTrackDataDetails create({
    String special_type = "berduTrackDataDetails",
    String? datetime,
    Object? shipperStatus,
    BerduTrackDataDetailLogisticStatus? logisticStatus,
    String? typename,
  }) {
    // BerduTrackDataDetails berduTrackDataDetails = BerduTrackDataDetails({

    BerduTrackDataDetails berduTrackDataDetails_data_create =
        BerduTrackDataDetails({
      "@type": special_type,
      "datetime": datetime,
      "shipperStatus": shipperStatus,
      "logisticStatus":
          (logisticStatus != null) ? logisticStatus.toJson() : null,
      "__typename": typename,
    });

// return berduTrackDataDetails;
    return berduTrackDataDetails_data_create;
  }
}
