// ignore_for_file: non_constant_identifier_names
import "json_dart.dart";
// import "dart:convert";

import "jne_berdu_raw_datas.dart";

class JneBerduRawData extends JsonSchemeRaw {
  JneBerduRawData(super.rawData);

  static Map get defaultData {
    return {
      "@type": "jneBerduRawData",
      "data": {
        "@type": "jneBerduRawDatas",
        "trackingDirect": [
          {
            "@type": "berduTrackData",
            "referenceNo": "CM96392284741",
            "logistic": {
              "@type": "berduTrackDataLogistic",
              "id": "1",
              "__typename": "Logistic"
            },
            "shipmentDate": "",
            "details": [
              {
                "@type": "berduTrackDataDetails",
                "datetime": "2023-05-16T02:56:00+07:00",
                "shipperStatus": null,
                "logisticStatus": {
                  "@type": "berduTrackDataDetailLogisticStatus",
                  "name":
                      "SHIPMENT RECEIVED BY JNE COUNTER OFFICER AT [variable]",
                  "description":
                      "SHIPMENT RECEIVED BY JNE COUNTER OFFICER AT [SOLO]",
                  "__typename": "TrackingDirectStatus"
                },
                "__typename": "TrackingDirectDetail"
              }
            ],
            "consigner": {
              "@type": "berduTrackDataConsigner",
              "name": "AEROSTREET",
              "address": "SOC10000",
              "__typename": "TrackingDirectIdentity"
            },
            "consignee": {
              "@type": "berduTrackDataConsignee",
              "name": "SARWOTO",
              "address": "",
              "__typename": "TrackingDirectIdentity"
            },
            "__typename": "TrackingDirect"
          }
        ]
      }
    };
  }

  String? get special_type {
    try {
      if (rawData["@type"] is String == false) {
        return null;
      }
      return rawData["@type"] as String;
    } catch (e) {
      return null;
    }
  }

  JneBerduRawDatas get data {
    try {
      if (rawData["data"] is Map == false) {
        return JneBerduRawDatas({});
      }
      return JneBerduRawDatas(rawData["data"] as Map);
    } catch (e) {
      return JneBerduRawDatas({});
    }
  }

  static JneBerduRawData create({
    String special_type = "jneBerduRawData",
    JneBerduRawDatas? data,
  }) {
    // JneBerduRawData jneBerduRawData = JneBerduRawData({

    JneBerduRawData jneBerduRawData_data_create = JneBerduRawData({
      "@type": special_type,
      "data": (data != null) ? data.toJson() : null,
    });

// return jneBerduRawData;
    return jneBerduRawData_data_create;
  }
}
