// ignore_for_file: non_constant_identifier_names
import "json_dart.dart";
// import "dart:convert";

import "berdu_track_data.dart";

class JneBerduRawDatas extends JsonSchemeRaw {
  JneBerduRawDatas(super.rawData);

  static Map get defaultData {
    return {
      "@type": "jneBerduRawDatas",
      "trackingDirect": [
        {
          "@type": "berduTrackData",
          "referenceNo": "CM96392284741",
          "logistic": {
            "@type": "berduTrackDataLogistic",
            "id": "1",
            "__typename": "Logistic"
          },
          "shipmentDate": "",
          "details": [
            {
              "@type": "berduTrackDataDetails",
              "datetime": "2023-05-16T02:56:00+07:00",
              "shipperStatus": null,
              "logisticStatus": {
                "@type": "berduTrackDataDetailLogisticStatus",
                "name":
                    "SHIPMENT RECEIVED BY JNE COUNTER OFFICER AT [variable]",
                "description":
                    "SHIPMENT RECEIVED BY JNE COUNTER OFFICER AT [SOLO]",
                "__typename": "TrackingDirectStatus"
              },
              "__typename": "TrackingDirectDetail"
            }
          ],
          "consigner": {
            "@type": "berduTrackDataConsigner",
            "name": "AEROSTREET",
            "address": "SOC10000",
            "__typename": "TrackingDirectIdentity"
          },
          "consignee": {
            "@type": "berduTrackDataConsignee",
            "name": "SARWOTO",
            "address": "",
            "__typename": "TrackingDirectIdentity"
          },
          "__typename": "TrackingDirect"
        }
      ]
    };
  }

  String? get special_type {
    try {
      if (rawData["@type"] is String == false) {
        return null;
      }
      return rawData["@type"] as String;
    } catch (e) {
      return null;
    }
  }

  List<BerduTrackData> get trackingDirect {
    try {
      if (rawData["trackingDirect"] is List == false) {
        return [];
      }
      return (rawData["trackingDirect"] as List)
          .map((e) => BerduTrackData(e as Map))
          .toList()
          .cast<BerduTrackData>();
    } catch (e) {
      return [];
    }
  }

  static JneBerduRawDatas create({
    String special_type = "jneBerduRawDatas",
    List<BerduTrackData>? trackingDirect,
  }) {
    // JneBerduRawDatas jneBerduRawDatas = JneBerduRawDatas({

    JneBerduRawDatas jneBerduRawDatas_data_create = JneBerduRawDatas({
      "@type": special_type,
      "trackingDirect":
          (trackingDirect != null) ? trackingDirect.toJson() : null,
    });

// return jneBerduRawDatas;
    return jneBerduRawDatas_data_create;
  }
}
