// ignore_for_file: non_constant_identifier_names
import "json_dart.dart";
// import "dart:convert";

import "sicepat_data_track_history.dart";
import "sicepat_data_last_status.dart";

class SicepatData extends JsonSchemeRaw {
  SicepatData(super.rawData);

  static Map get defaultData {
    return {
      "@type": "sicepatData",
      "waybill_number": "005208225151",
      "kodeasal": null,
      "kodetujuan": null,
      "service": "REG",
      "weight": 1,
      "partner": "Tokopedia",
      "sender": "Decathlon Indonesia",
      "sender_address": "DKI Jakarta",
      "receiver_address": "Kotabaru, Kab. Karawang",
      "receiver_name": "Hendi",
      "realprice": 0,
      "totalprice": 14000,
      "POD_receiver": "Paket diterima oleh [hendi - (YBS) Yang Bersangkutan]",
      "POD_receiver_time": "2023-05-24 10:13",
      "send_date": "2023-05-23 03:32",
      "track_history": [
        {
          "@type": "sicepatDataTrackHistory",
          "date_time": "2023-05-22 15:40",
          "status": "PICKREQ",
          "city": "Terima permintaan pick up dari [Tokopedia]"
        }
      ],
      "last_status": {
        "@type": "sicepatDataLastStatus",
        "date_time": "2023-05-24 10:13",
        "status": "DELIVERED",
        "receiver_name": "Paket diterima oleh [hendi - (YBS) Yang Bersangkutan]"
      },
      "perwakilan": "KLC",
      "pop_sigesit_img_path":
          "https://imgproxy.sicepat.com/TMVnsfVC2AEXoev5vnLyMRp4_jcdB1heC-_J7zlzeGk/rs:fit:768:1024:0/g:no/aHR0cHM6Ly9zaWNlcGF0bWFzdGVyZGF0YS5zMy5hcC1zb3V0aGVhc3QtMS5hbWF6b25hd3MuY29tL2ltYWdlcy9lbXBsb3llZS8yMDA4MDc3MC5qcGc.jpg",
      "pod_sigesit_img_path":
          "https://imgproxy.sicepat.com/qeq8TgxrP9jJIC9kiji6GBaiCNMet9FYScXyrRH7ybQ/rs:fit:768:1024:0/g:no/aHR0cHM6Ly9zaWNlcGF0bWFzdGVyZGF0YS5zMy5hcC1zb3V0aGVhc3QtMS5hbWF6b25hd3MuY29tL2ltYWdlcy9lbXBsb3llZS8yMTA1MTk1MS5qcGc.jpg",
      "pod_sign_img_path": null,
      "pod_img_path": null,
      "pop_img_path": null,
      "manifested_img_path": null
    };
  }

  String? get special_type {
    try {
      if (rawData["@type"] is String == false) {
        return null;
      }
      return rawData["@type"] as String;
    } catch (e) {
      return null;
    }
  }

  String? get waybill_number {
    try {
      if (rawData["waybill_number"] is String == false) {
        return null;
      }
      return rawData["waybill_number"] as String;
    } catch (e) {
      return null;
    }
  }

  Object? get kodeasal {
    try {
      if (rawData["kodeasal"] is Object == false) {
        return null;
      }
      return rawData["kodeasal"] as Object;
    } catch (e) {
      return null;
    }
  }

  Object? get kodetujuan {
    try {
      if (rawData["kodetujuan"] is Object == false) {
        return null;
      }
      return rawData["kodetujuan"] as Object;
    } catch (e) {
      return null;
    }
  }

  String? get service {
    try {
      if (rawData["service"] is String == false) {
        return null;
      }
      return rawData["service"] as String;
    } catch (e) {
      return null;
    }
  }

  int? get weight {
    try {
      if (rawData["weight"] is int == false) {
        return null;
      }
      return rawData["weight"] as int;
    } catch (e) {
      return null;
    }
  }

  String? get partner {
    try {
      if (rawData["partner"] is String == false) {
        return null;
      }
      return rawData["partner"] as String;
    } catch (e) {
      return null;
    }
  }

  String? get sender {
    try {
      if (rawData["sender"] is String == false) {
        return null;
      }
      return rawData["sender"] as String;
    } catch (e) {
      return null;
    }
  }

  String? get sender_address {
    try {
      if (rawData["sender_address"] is String == false) {
        return null;
      }
      return rawData["sender_address"] as String;
    } catch (e) {
      return null;
    }
  }

  String? get receiver_address {
    try {
      if (rawData["receiver_address"] is String == false) {
        return null;
      }
      return rawData["receiver_address"] as String;
    } catch (e) {
      return null;
    }
  }

  String? get receiver_name {
    try {
      if (rawData["receiver_name"] is String == false) {
        return null;
      }
      return rawData["receiver_name"] as String;
    } catch (e) {
      return null;
    }
  }

  int? get realprice {
    try {
      if (rawData["realprice"] is int == false) {
        return null;
      }
      return rawData["realprice"] as int;
    } catch (e) {
      return null;
    }
  }

  int? get totalprice {
    try {
      if (rawData["totalprice"] is int == false) {
        return null;
      }
      return rawData["totalprice"] as int;
    } catch (e) {
      return null;
    }
  }

  String? get POD_receiver {
    try {
      if (rawData["POD_receiver"] is String == false) {
        return null;
      }
      return rawData["POD_receiver"] as String;
    } catch (e) {
      return null;
    }
  }

  String? get POD_receiver_time {
    try {
      if (rawData["POD_receiver_time"] is String == false) {
        return null;
      }
      return rawData["POD_receiver_time"] as String;
    } catch (e) {
      return null;
    }
  }

  String? get send_date {
    try {
      if (rawData["send_date"] is String == false) {
        return null;
      }
      return rawData["send_date"] as String;
    } catch (e) {
      return null;
    }
  }

  List<SicepatDataTrackHistory> get track_history {
    try {
      if (rawData["track_history"] is List == false) {
        return [];
      }
      return (rawData["track_history"] as List)
          .map((e) => SicepatDataTrackHistory(e as Map))
          .toList()
          .cast<SicepatDataTrackHistory>();
    } catch (e) {
      return [];
    }
  }

  SicepatDataLastStatus get last_status {
    try {
      if (rawData["last_status"] is Map == false) {
        return SicepatDataLastStatus({});
      }
      return SicepatDataLastStatus(rawData["last_status"] as Map);
    } catch (e) {
      return SicepatDataLastStatus({});
    }
  }

  String? get perwakilan {
    try {
      if (rawData["perwakilan"] is String == false) {
        return null;
      }
      return rawData["perwakilan"] as String;
    } catch (e) {
      return null;
    }
  }

  String? get pop_sigesit_img_path {
    try {
      if (rawData["pop_sigesit_img_path"] is String == false) {
        return null;
      }
      return rawData["pop_sigesit_img_path"] as String;
    } catch (e) {
      return null;
    }
  }

  String? get pod_sigesit_img_path {
    try {
      if (rawData["pod_sigesit_img_path"] is String == false) {
        return null;
      }
      return rawData["pod_sigesit_img_path"] as String;
    } catch (e) {
      return null;
    }
  }

  Object? get pod_sign_img_path {
    try {
      if (rawData["pod_sign_img_path"] is Object == false) {
        return null;
      }
      return rawData["pod_sign_img_path"] as Object;
    } catch (e) {
      return null;
    }
  }

  Object? get pod_img_path {
    try {
      if (rawData["pod_img_path"] is Object == false) {
        return null;
      }
      return rawData["pod_img_path"] as Object;
    } catch (e) {
      return null;
    }
  }

  Object? get pop_img_path {
    try {
      if (rawData["pop_img_path"] is Object == false) {
        return null;
      }
      return rawData["pop_img_path"] as Object;
    } catch (e) {
      return null;
    }
  }

  Object? get manifested_img_path {
    try {
      if (rawData["manifested_img_path"] is Object == false) {
        return null;
      }
      return rawData["manifested_img_path"] as Object;
    } catch (e) {
      return null;
    }
  }

  static SicepatData create({
    String special_type = "sicepatData",
    String? waybill_number,
    Object? kodeasal,
    Object? kodetujuan,
    String? service,
    int? weight,
    String? partner,
    String? sender,
    String? sender_address,
    String? receiver_address,
    String? receiver_name,
    int? realprice,
    int? totalprice,
    String? POD_receiver,
    String? POD_receiver_time,
    String? send_date,
    List<SicepatDataTrackHistory>? track_history,
    SicepatDataLastStatus? last_status,
    String? perwakilan,
    String? pop_sigesit_img_path,
    String? pod_sigesit_img_path,
    Object? pod_sign_img_path,
    Object? pod_img_path,
    Object? pop_img_path,
    Object? manifested_img_path,
  }) {
    // SicepatData sicepatData = SicepatData({

    SicepatData sicepatData_data_create = SicepatData({
      "@type": special_type,
      "waybill_number": waybill_number,
      "kodeasal": kodeasal,
      "kodetujuan": kodetujuan,
      "service": service,
      "weight": weight,
      "partner": partner,
      "sender": sender,
      "sender_address": sender_address,
      "receiver_address": receiver_address,
      "receiver_name": receiver_name,
      "realprice": realprice,
      "totalprice": totalprice,
      "POD_receiver": POD_receiver,
      "POD_receiver_time": POD_receiver_time,
      "send_date": send_date,
      "track_history": (track_history != null) ? track_history.toJson() : null,
      "last_status": (last_status != null) ? last_status.toJson() : null,
      "perwakilan": perwakilan,
      "pop_sigesit_img_path": pop_sigesit_img_path,
      "pod_sigesit_img_path": pod_sigesit_img_path,
      "pod_sign_img_path": pod_sign_img_path,
      "pod_img_path": pod_img_path,
      "pop_img_path": pop_img_path,
      "manifested_img_path": manifested_img_path,
    });

// return sicepatData;
    return sicepatData_data_create;
  }
}
