// ignore_for_file: non_constant_identifier_names
import "json_dart.dart";
// import "dart:convert";

import "sicepat_data_body.dart";

class SicepatRawData extends JsonSchemeRaw {
  SicepatRawData(super.rawData);

  static Map get defaultData {
    return {
      "@type": "sicepatRawData",
      "sicepat": {
        "@type": "sicepatDataBody",
        "status": {
          "@type": "sicepatDataStatus",
          "code": 200,
          "description": "OK"
        },
        "result": {
          "@type": "sicepatData",
          "waybill_number": "005208225151",
          "kodeasal": null,
          "kodetujuan": null,
          "service": "REG",
          "weight": 1,
          "partner": "Tokopedia",
          "sender": "Decathlon Indonesia",
          "sender_address": "DKI Jakarta",
          "receiver_address": "Kotabaru, Kab. Karawang",
          "receiver_name": "Hendi",
          "realprice": 0,
          "totalprice": 14000,
          "POD_receiver":
              "Paket diterima oleh [hendi - (YBS) Yang Bersangkutan]",
          "POD_receiver_time": "2023-05-24 10:13",
          "send_date": "2023-05-23 03:32",
          "track_history": [
            {
              "@type": "sicepatDataTrackHistory",
              "date_time": "2023-05-22 15:40",
              "status": "PICKREQ",
              "city": "Terima permintaan pick up dari [Tokopedia]"
            }
          ],
          "last_status": {
            "@type": "sicepatDataLastStatus",
            "date_time": "2023-05-24 10:13",
            "status": "DELIVERED",
            "receiver_name":
                "Paket diterima oleh [hendi - (YBS) Yang Bersangkutan]"
          },
          "perwakilan": "KLC",
          "pop_sigesit_img_path":
              "https://imgproxy.sicepat.com/TMVnsfVC2AEXoev5vnLyMRp4_jcdB1heC-_J7zlzeGk/rs:fit:768:1024:0/g:no/aHR0cHM6Ly9zaWNlcGF0bWFzdGVyZGF0YS5zMy5hcC1zb3V0aGVhc3QtMS5hbWF6b25hd3MuY29tL2ltYWdlcy9lbXBsb3llZS8yMDA4MDc3MC5qcGc.jpg",
          "pod_sigesit_img_path":
              "https://imgproxy.sicepat.com/qeq8TgxrP9jJIC9kiji6GBaiCNMet9FYScXyrRH7ybQ/rs:fit:768:1024:0/g:no/aHR0cHM6Ly9zaWNlcGF0bWFzdGVyZGF0YS5zMy5hcC1zb3V0aGVhc3QtMS5hbWF6b25hd3MuY29tL2ltYWdlcy9lbXBsb3llZS8yMTA1MTk1MS5qcGc.jpg",
          "pod_sign_img_path": null,
          "pod_img_path": null,
          "pop_img_path": null,
          "manifested_img_path": null
        }
      },
      "sfExpress": [""],
      "aramex": [""]
    };
  }

  String? get special_type {
    try {
      if (rawData["@type"] is String == false) {
        return null;
      }
      return rawData["@type"] as String;
    } catch (e) {
      return null;
    }
  }

  SicepatDataBody get sicepat {
    try {
      if (rawData["sicepat"] is Map == false) {
        return SicepatDataBody({});
      }
      return SicepatDataBody(rawData["sicepat"] as Map);
    } catch (e) {
      return SicepatDataBody({});
    }
  }

  List<String> get sfExpress {
    try {
      if (rawData["sfExpress"] is List == false) {
        return [];
      }
      return (rawData["sfExpress"] as List).cast<String>();
    } catch (e) {
      return [];
    }
  }

  List<String> get aramex {
    try {
      if (rawData["aramex"] is List == false) {
        return [];
      }
      return (rawData["aramex"] as List).cast<String>();
    } catch (e) {
      return [];
    }
  }

  static SicepatRawData create({
    String special_type = "sicepatRawData",
    SicepatDataBody? sicepat,
    List<String>? sfExpress,
    List<String>? aramex,
  }) {
    // SicepatRawData sicepatRawData = SicepatRawData({

    SicepatRawData sicepatRawData_data_create = SicepatRawData({
      "@type": special_type,
      "sicepat": (sicepat != null) ? sicepat.toJson() : null,
      "sfExpress": sfExpress,
      "aramex": aramex,
    });

// return sicepatRawData;
    return sicepatRawData_data_create;
  }
}
